<%@ page import="gov.bnl.gums.GridUser" %>
<%@ page import="gov.bnl.gums.configuration.*" %>
<%@ page import="gov.bnl.gums.configuration.ConfigElement.ConfigField" %>
<%@ page import="gov.bnl.gums.service.ConfigurationWebToolkit" %>
<%@ page import="gov.bnl.gums.util.StringUtil" %>
<%@ page import="gov.bnl.gums.userGroup.*" %>
<%@ page import="java.util.*" %>

<jsp:useBean id="gums" scope="application" class="gov.bnl.gums.admin.GUMSAPIImpl" />

<%
String pageName = request.getParameter("pageName");
String configElementName = request.getParameter("configElementName");
Class<ConfigElement> configElementClass = (Class<ConfigElement>)Class.forName(request.getParameter("configElementClass"));
Class<ConfigElement> defaultConfigElementClass = (Class<ConfigElement>)Class.forName(request.getParameter("defaultConfigElementClass"));

Configuration configuration = null;
try {
	configuration = gums.getConfiguration();
}catch(Exception e){
	out.write("<p><div class=\"failure\">" + e.getMessage() + "</div></p>");
}

if (configuration!=null) {
	String message = null;
	
	if (request.getParameter("command")==null || 
		"save".equals(request.getParameter("command")) || 
		"delete".equals(request.getParameter("command"))) {
		
		if ("save".equals(request.getParameter("command"))) {
			Configuration newConfiguration = (Configuration)configuration.clone();
			try{
				newConfiguration.removeConfigElement( request.getParameter("ce_name"), configElementClass, false );
				newConfiguration.addConfigElement( ConfigurationWebToolkit.parseConfigElement(request) );
				gums.setConfiguration(newConfiguration);
				configuration = gums.getConfiguration();
				message = "<div class=\"success\">" + configElementName.toLowerCase() + " has been saved.</div>";
			}catch(Exception e){
				message = "<div class=\"failure\">Error saving " + configElementName.toLowerCase() + ": " + e.getMessage() + "</div>";
			}
		}
	
		if ("delete".equals(request.getParameter("command"))) {
			Configuration newConfiguration = (Configuration)configuration.clone();
			try{
				if (newConfiguration.removeConfigElement( request.getParameter("ce_name"), configElementClass, true )!=null) {
					gums.setConfiguration(newConfiguration);
					configuration = gums.getConfiguration();
					message = "<div class=\"success\">" + configElementName.toLowerCase() + " has been deleted.</div>";
				}
				else
					message = "<div class=\"failure\">Error deleting " + configElementName.toLowerCase() + "</div>";
			}catch(Exception e){
				e.printStackTrace(response.getWriter());
				message = "<div class=\"failure\">Error deleting " + configElementName.toLowerCase() + ": " + e.getMessage() + "</div>";
			}
		}
		
		out.write(
		"<table id=\"form\" cellpadding=\"2\" cellspacing=\"2\">");
	
		if(message!=null)
			out.write( 
			"<tr><td colspan=\"2\">" + message + "</td></tr>" );
					
		for (ConfigElement configElement: configuration.getConfigElements(configElementClass)) {
			if (configElement.getName().startsWith("_test") || configElement.getName().equals("/DC=com/DC=example/OU=Services/CN=example.site.com"))
				continue;
	%>
		   	<tr>
				<td width="1" valign="top">
					<form action="<%=pageName%>" method="get">
						<input type="hidden" name="ce_name" value="<%=configElement.getName()%>">
						<input type="submit" style="width:80px" name="command" value="edit">
						<input type="submit" style="width:80px" name="command" value="delete" onclick="if(!confirm('Are you sure you want to delete this <%=configElementName.toLowerCase()%>?'))return false;">
					</form>
				</td>
		  		<td align="left">
			   		<table class="configElement" width="100%">
			  			<tr>
				    		<td>
	<%		
			for (ConfigField configField: configElement.getConfigFields()) {
				if (configField.configFieldAnnotation.showInConciseView()) {
					out.write(""+configField.configFieldAnnotation.label() + ": ");
					out.write(""+ConfigurationWebToolkit.blankNull(configField.value));
					out.write("</br>");
				}
			}	
	%>	
							</td>
				      	</tr>
					</table>
				</td>
				<td width="10"></td>		
			</tr>
	<%
		}
	%>	
			<tr>
		        <td colspan=2>
		        	<form action="<%=pageName%>" method="get">
		        		<div style="text-align: center;"><input type="submit" name="command" value="add"></div>
		        	</form>
		        </td>
			</tr>
		  </table>
	</form>
	<%
	}
	
	else if ("edit".equals(request.getParameter("command"))
		|| "add".equals(request.getParameter("command"))
		|| "reload".equals(request.getParameter("command"))) {
		
		ConfigElement configElement = null;
		
		if ("edit".equals(request.getParameter("command"))) {
			try {
				configElement = configuration.getConfigElement(configElementClass, request.getParameter("ce_name") );
			} catch(Exception e) {
				out.write( "<div class=\"failure\">Error getting " + configElementName.toLowerCase() + ": " + e.getMessage() + "</div>" );
				return;
			}
		}
	
		if ("reload".equals(request.getParameter("command"))) {
			try{
				configElement = ConfigurationWebToolkit.parseConfigElement(request);
			} catch(Exception e) {
				out.write( "<div class=\"failure\">Error reloading " + configElementName.toLowerCase() + ": " + e.getMessage() + "</div>" );
				return;
			}
		}
			
		else if ("add".equals(request.getParameter("command"))) {
			configElement = defaultConfigElementClass.newInstance();
		}		
			
	%>
	<form action="<%=pageName%>" method="get">
		<input type="hidden" name="command" value="">
		<input type="hidden" name="originalCommand" value="<%=("reload".equals(request.getParameter("command")) ? request.getParameter("originalCommand") : request.getParameter("command"))%>">
		<table id="form" border="0" cellpadding="2" cellspacing="2" align="center">
			<tr>
	    		<td nowrap style="text-align: right;">
		    		Class:
			    </td>
			    <td nowrap>
				<%=ConfigurationWebToolkit.createSelectBox(
					"class", 
					ConfigurationToolkit.getConfigElementTypes(configElementClass), 
					request.getParameter("class")!=null ? request.getParameter("class") : defaultConfigElementClass.getName(),
					"onchange=\"document.forms[0].elements['command'].value='reload';document.forms[0].submit();\"",
					false)%>
			    </td>
			</tr>
	<%
		for (ConfigField configField: configElement.getConfigFields()) {
			String htmlName = "ce_" + configField.configFieldName;
	%>
			<tr>
	    		<td nowrap style="text-align: right;">
	    			<%=configField.configFieldAnnotation.label()%>
			    </td>
			    <td nowrap>
	<%
				if (configField.configFieldAnnotation.choices().length()>0) {
					out.write(ConfigurationWebToolkit.createSelectBox(
						htmlName, 
						StringUtil.toList(configField.configFieldAnnotation.choices()), 
						configField.value.toString(),
						"onchange=\"document.forms[0].elements['command'].value='reload';document.forms[0].submit();\"",
						false));
				}
				else if (configField.configFieldAnnotation.orderedList()) {
					out.write(ConfigurationWebToolkit.createOrderedList(
						htmlName, 
						StringUtil.toList((String)configField.value), 
						"onchange=\"document.forms[0].elements['command'].value='reload';document.forms[0].submit();\""));
				}
				else if (configField.type == Boolean.class || configField.type == boolean.class) {
					out.write("<input type=\"checkbox\" name=\"" + htmlName + "\" value=\"" + ConfigurationWebToolkit.blankNull(configField.value) + "\"/>");
				}
				else if (configField.type == String.class) {
					out.write("<input maxlength=\"256\" size=" + configField.configFieldAnnotation.size() + " name=\"" + htmlName + "\" value=\"" + ConfigurationWebToolkit.blankNull(configField.value) + "\"/>");
				} 
	%>
			    <%=configField.configFieldAnnotation.help().length()>0 ? "("+configField.configFieldAnnotation.help()+")" : ""%></td> 
	<%		    
			    if (configField.configFieldAnnotation.example().length() > 0) {
	%>
				<tr>
					<td nowrap style="text-align: right;">
			    		i.e.
				    </td>
				    <td nowrap>
						<%=configField.configFieldAnnotation.example()%>
				    </td>
				</tr>	
	<%			}
	%>
			</tr>
	<%		}
	%>
			<tr>
		        <td colspan=2>
					<%=ConfigurationWebToolkit.createDoSubmit(configuration.getConfigElements(configElementClass), request)%>
		        	<div style="text-align: center;">
		        		<button type="submit" onclick="return doSubmit()">save</button>
		        	</div>
		        </td>
			</tr>
		</table>
	</form>
	<%
	}
}

%>
