<%@ page contentType="text/html" %>
<%@ page pageEncoding="UTF-8" %>

<%@ page import="gov.bnl.gums.*" %>
<%@ page import="gov.bnl.gums.service.*" %>
<%@ page import="java.util.*" %>
<%@ page import="gov.bnl.gums.configuration.Configuration" %>

<jsp:useBean id="gums" scope="application" class="gov.bnl.gums.admin.GUMSAPIImpl" />

<%@include file="sideNav.jspf"%>

<jsp:include page="topNav.jsp" >
	<jsp:param name="version" value="<%=gums.getVersion()%>" />
	<jsp:param name="pageTitle" value="Configuration" />
	<jsp:param name="pageDescription" value="Set global configuration attributes" />
</jsp:include>

<%
Configuration configuration = null;
try {
	configuration = gums.getConfiguration();
}catch(Exception e){
	out.write("<p><div class=\"failure\">" + e.getMessage() + "</div></p>");
}
if (configuration!=null) {
	String[] bannedUserGroups = new String[0];
	boolean allowGridMapfiles = true;
	String message = null;
	if ("save".equals(request.getParameter("command"))) {
		Configuration newConfiguration = (Configuration)configuration.clone();
		try{
			newConfiguration.setAllowGridmapFiles("on".equals(request.getParameter("allowGMP")));
			newConfiguration.setSslCAFiles(request.getParameter("sslCAFiles"));
			newConfiguration.setSslCertfile(request.getParameter("sslCertfile"));
			newConfiguration.setSslKey(request.getParameter("sslKey"));
			newConfiguration.setSslKeyPasswd(request.getParameter("sslKeyPasswd"));
			StringBuffer buffer = new StringBuffer();
			int counter = 0;
			while(request.getParameter("bug" + counter)!=null) {
				String userGroupName = request.getParameter("bug" + counter).trim();
				if (!userGroupName.equals(""))
					buffer.append(userGroupName+",");
				counter++;
			}
			if (buffer.length()>0 && buffer.charAt(buffer.length()-1)==',')
				buffer.replace(buffer.length()-1, buffer.length(), "");
			newConfiguration.setBannedUserGroups(buffer.toString());
			gums.setConfiguration(newConfiguration);
			configuration = gums.getConfiguration();
			if (configuration.getBannedUserGroups().length()>0)
				bannedUserGroups = configuration.getBannedUserGroups().split(",");
			allowGridMapfiles = "on".equals(request.getParameter("allowGMP"));
			message = "<div class=\"success\">Configuration has been saved.</div>";
		}catch(Exception e){
			message = "<div class=\"failure\">Error saving configuration: " + e.getMessage() + "</div>";
		}
	}
	
	else if ("reload".equals(request.getParameter("command"))) {
		try{
			int counter = 0;
			ArrayList<String> tempArray = new ArrayList<String>();
			while(request.getParameter("bug" + counter)!=null) {
				String userGroupName = request.getParameter("bug" + counter).trim();
				if (!userGroupName.equals(""))
					tempArray.add(userGroupName);
				counter++;
			}
			bannedUserGroups = new String[tempArray.size()];
			Iterator<String> it = tempArray.iterator();
			counter = 0;
			while (it.hasNext()) {
				bannedUserGroups[counter] = (String)it.next();
				counter++;
			}
			allowGridMapfiles = "on".equals(request.getParameter("allowGMP"));
		} catch(Exception e) {
			out.write( "<div class=\"failure\">Error reloading host to group mapping: " + e.getMessage() + "</div>" );
			return;
		}
	}
	
	else {
		try{
			if (configuration.getBannedUserGroups()!=null && configuration.getBannedUserGroups().length()>0)
				bannedUserGroups = configuration.getBannedUserGroups().split(",");
			else
				bannedUserGroups = new String[0];
			allowGridMapfiles = configuration.isAllowGridmapFiles();
		} catch(Exception e) {
			out.write( "<div class=\"failure\">Error loading host to group mapping: " + e.getMessage() + "</div>" );
			return;
		}
	}
	
	if(message!=null)
		out.write( 
			"<tr><td colspan=\"2\">" + message + "</td></tr>" );
	
%>
<form action="globalConfiguration.jsp" method="get">
	<input type="hidden" name="command" value="save">
	<input type="hidden" name="insertCounter">
	
	<table id="form" cellpadding="2" cellspacing="2">
	   	<tr>
	   		<td nowrap style="text-align: right;">
	    		<input type="checkbox" name="allowGMP" <%=allowGridMapfiles?"CHECKED":""%>>
		    </td>
			<td>
				Allow grid mapfile generation (uncheck if not needed so that users that don't use your site will not use up pool accounts)
			</td>
		</tr>
		<tr>
			<td nowrap style="text-align: right;">
	    		Banned User Groups:
		    </td>
		    <td nowrap>
<%
				// Create multiple group to account mappings
				int counter = 0;
			 	int lastCounter = bannedUserGroups.length;
				int insertCounter = lastCounter;
				if (request.getParameter("insertCounter")!=null && !request.getParameter("insertCounter").equals(""))
					insertCounter = Integer.parseInt(request.getParameter("insertCounter"));
				for (int i=0; i<lastCounter; i++) {
					String bannedUserGroup = bannedUserGroups[i].trim();
					if (counter!=insertCounter)
						out.write("<a href=\"javascript:void(0)\" onclick=\"document.forms[0].elements['command'].value='reload';document.forms[0].elements['insertCounter'].value='"+counter+"';document.forms[0].submit();\" title=\"insert here\">+</a> ");
					int numRepetitions = (counter==insertCounter)?2:1;
			        for (int j=0; j<numRepetitions; j++) {
						out.write( 
							ConfigurationWebToolkit.createSelectBox("bug"+counter,
								configuration.getUserGroups().values(),
								(counter==insertCounter) ? null : bannedUserGroup,
								"onchange=\"document.forms[0].elements['command'].value='reload';document.forms[0].submit();\"",
								true) );
			 			counter++;
			 		}
				}
				if (insertCounter==lastCounter) {
					out.write( 
						ConfigurationWebToolkit.createSelectBox("bug"+lastCounter, 
							configuration.getUserGroups().values(), 
							null,
							"onchange=\"document.forms[0].elements['command'].value='reload';document.forms[0].submit();\"",
							true) );
				}
				else
					out.write("<a href=\"javascript:void(0)\" onclick=\"document.forms[0].elements['command'].value='reload';document.forms[0].elements['insertCounter'].value='"+lastCounter+"';document.forms[0].submit();\" title=\"insert here\">+</a> ");
				%> 
			(optional) </td>
		</tr>
		<tr>
    		<td nowrap style="text-align: right;">
	    		SSL CA Files
		    </td>
		    <td nowrap>
		    	<input size=32 name="sslCAFiles" value="<%=ConfigurationWebToolkit.blankNull(configuration.getSslCAFiles())%>"/>
		    </td>
		</tr>
		<tr>
			<td nowrap style="text-align: right;">
	    		i.e.
		    </td>
			<td nowrap>
				/etc/grid-security/certificates/*.0
			</td>
		</tr>		
		<tr>
			<td nowrap style="text-align: right;">
	    		SSL Cert File
		    </td>
			<td nowrap>
				<input size=32 name="sslCertfile" value="<%=ConfigurationWebToolkit.blankNull(configuration.getSslCertfile())%>"/>
			</td>
		</tr>
		<tr>
			<td nowrap style="text-align: right;">
	    		i.e.
		    </td>
			<td nowrap>
				/etc/grid-security/http/httpcert.pem
			</td>
		</tr>
		<tr>
			<td nowrap style="text-align: right;">
	    		SSL Key
		    </td>
			<td nowrap>
				<input size=32 name="sslKey" value="<%=ConfigurationWebToolkit.blankNull(configuration.getSslKey())%>"/>
			</td>
		</tr>
		<tr>
			<td nowrap style="text-align: right;">
	    		i.e.
		    </td>
			<td nowrap>
				/etc/grid-security/http/httpkey.pem
			</td>
		</tr>		
		<tr>
			<td nowrap style="text-align: right;">
	    		SSL Key Password
		    </td>
			<td nowrap>
				<input type="password" size=32 name="sslKeyPasswd" value="<%=ConfigurationWebToolkit.blankNull(configuration.getSslKeyPasswd())%>"/> (optional)
			</td>
		</tr>		
		<tr>
			<td colspan=2>
	        	<div style="text-align: center;">
	        		<button type="submit">save</button>
	        	</div>
	        </td>
		</tr>
	  </table>
</form>

<%}%>
<jsp:include page="bottomNav.jsp" >
	<jsp:param name="userDn" value="<%=gums.getCurrentDn()%>" />
</jsp:include>
