<%@ page contentType="text/html" %>
<%@ page pageEncoding="UTF-8" %>

<%@ page import="gov.bnl.gums.userGroup.*" %>
<%@ page import="gov.bnl.gums.GridUser" %>
<%@ page import="gov.bnl.gums.configuration.*" %>
<%@ page import="gov.bnl.gums.service.ConfigurationWebToolkit" %>
<%@ page import="java.util.*" %>

<jsp:useBean id="gums" scope="application" class="gov.bnl.gums.admin.GUMSAPIImpl" />

<%@include file="sideNav.jspf"%>

<jsp:include page="topNav.jsp" >
	<jsp:param name="version" value="<%=gums.getVersion()%>" />
	<jsp:param name="pageTitle" value="Manual User Group Members" />
	<jsp:param name="pageDescription" value="Configures users in manual user groups" />
</jsp:include>

<%
Configuration configuration = null;
try {
	configuration = gums.getConfiguration();
}catch(Exception e){
	out.write("<p><div class=\"failure\">" + e.getMessage() + "</div></p>");
	return;
}
if (configuration!=null) {
	Map userGroups = configuration.getUserGroups();
	String message = null;
	
	if (request.getParameter("command")==null || 
		"save".equals(request.getParameter("command")) || 
		"delete".equals(request.getParameter("command"))) {
		
		if ("save".equals(request.getParameter("command"))) {
			ManualUserGroup manualUserGroup = (ManualUserGroup)userGroups.get(request.getParameter("userGroup"));
			try{
				gums.manualGroupAdd3(manualUserGroup.getName(), request.getParameter("dn"), request.getParameter("fqan"), request.getParameter("email"));
				message = "<div class=\"success\">User has been saved.</div>";
			}catch(Exception e){
				message = "<div class=\"failure\">Error saving user: " + e.getMessage() + "</div>";
			}
		}
	
		if ("delete".equals(request.getParameter("command"))) {
			ManualUserGroup manualUserGroup = (ManualUserGroup)userGroups.get(request.getParameter("userGroup"));
			try{
				gums.manualGroupRemove3(manualUserGroup.getName(), request.getParameter("dn"), request.getParameter("fqan"));
				message = "<div class=\"success\">User has been deleted.</div>";
			}catch(Exception e){
				message = "<div class=\"failure\">Error deleting user: " + e.getMessage() + "</div>";
			}
		}
	
		out.write(
	"<table id=\"form\" cellpadding=\"2\" cellspacing=\"2\">");
	
		if(message!=null)
			out.write( 
		"<tr><td colspan=\"2\">" + message + "</td></tr>" );
					
		Iterator userGroupsIt = userGroups.values().iterator();
		while(userGroupsIt.hasNext()) {
			UserGroup userGroup = (UserGroup)userGroupsIt.next();
			if (userGroup instanceof ManualUserGroup) {
				ManualUserGroup manualUserGroup = (ManualUserGroup)userGroup;
				
				for (GridUser user: manualUserGroup.getMembers()) {
					if ("/DC=com/DC=example/OU=People/CN=Example User 12345".equals(user.getDn()))
						continue;
	%>
	   	<tr>
			<td width="25" valign="top">
				<form action="manualUserGroups.jsp" method="get">
					<input type="submit" style="width:80px"  name="command" value="delete" onclick="if(!confirm('Are you sure you want to delete this user?'))return false;">
					<input type="hidden" name="dn" value="<%=user.getDn()%>">
					<input type="hidden" name="fqan" value="<%=user.getFqan()!=null?user.getFqan():""%>">
					<input type="hidden" name="email" value="<%=user.getEmail()!=null?user.getEmail():""%>">
					<input type="hidden" name="userGroup" value="<%=manualUserGroup.getName()%>">
				</form>
			</td>
	  		<td align="left">
		   		<table class="userElement" width="100%">
		  			<tr>
			    		<td>
				    		DN: <%=user.getDn()%><br>
				    		User Group: <a href="userGroups.jsp?name=<%=manualUserGroup.getName()%>&command=edit"><%=manualUserGroup.getName()%></a><br>
				    		FQAN: <%=user.getFqan()!=null?user.getFqan():""%><br>
				    		Email: <%=user.getEmail()!=null?user.getEmail():""%><br>
			    		</td>
		  			</tr>
				</table>
			</td>
			<td width="10"></td>		
		</tr>
	<%
				}
			}
		}
	%>
		<tr>
			<td colspan=2>
				<form action="manualUserGroups.jsp" method="get">
					<div style="text-align: center;"><input type="submit" name="command" value="add"></div>
				</form>
		    </td>
		</tr>
	  </table>
	</form>
	<%
	}
	
	else if ("add".equals(request.getParameter("command"))) {
		
		GridUser user = new GridUser();
		
		ArrayList manualUserGroups = new ArrayList();
		Iterator userGroupIt = userGroups.values().iterator();
		while(userGroupIt.hasNext()) {
			UserGroup userGroup = (UserGroup)userGroupIt.next();
			if (userGroup instanceof ManualUserGroup)
				manualUserGroups.add(userGroup.getName());
		}
	%>
	<form action="manualUserGroups.jsp" method="get">
		<input type="hidden" name="command" value="">
		<table id="form" border="0" cellpadding="2" cellspacing="2" align="center">
			<tr>
				<td nowrap style="text-align: right;">
					User group:
				</td>
				<td>
					<%=ConfigurationWebToolkit.createSelectBox("userGroup", manualUserGroups, null, null, manualUserGroups.size()>1)%> (required)
				</td>
			</tr>
			<tr>
	    		<td nowrap style="text-align: right;">
		    		DN:
			    </td>
			    <td nowrap>
				    <input maxlength="256" size="64" name="dn" value=""/>  (regular expression)
			    </td>
			</tr>
			<tr>
	    		<td nowrap style="text-align: right;">
		    		i.e.
			    </td>
			    <td nowrap>
				    /DC=org/DC=doegrids/OU=People/CN=Jane Doe 12345<br>
				    /DC=org/DC=doegrids/OU=People/CN=.* (match against all doegrids users)
			    </td>
			</tr>
			<tr>
	    		<td nowrap style="text-align: right;">
		    		FQAN:
			    </td>
			    <td nowrap>
				    <input maxlength="256" size="64" name="fqan" value=""/> (optional regular expression)
			    </td>
			</tr>			
			<tr>
	    		<td nowrap style="text-align: right;">
		    		i.e.
			    </td>
			    <td nowrap>
			        /myvo/mysubvo/Role=myrole<br>
				    {blank} (match against grid proxies only)<br>
				    .* (match against grid and extended proxies)<br>
					/myvo/.* (match against 'myvo' VO)<br>
					/myvo/myvogroup/.* (match against 'myvo' VO and 'myvogroup' group)
			    </td>
			</tr>		
			<tr>
	    		<td nowrap style="text-align: right;">
		    		email:
			    </td>
			    <td nowrap>
				    <input maxlength="256" size="64" name="email" value=""/> (optional)
			    </td>
			</tr>		
			<tr>
		        <td colspan=2>
		        	<div style="text-align: center;">
		        		<button type="submit" onclick="document.forms[0].elements['command'].value='save'; return true;">save</button>
		        	</div>
		        </td>
			</tr>
		</table>
	</form>
	<%
	}
}%>
<jsp:include page="bottomNav.jsp" >
	<jsp:param name="userDn" value="<%=gums.getCurrentDn()%>" />
</jsp:include>
		
