<%@ page contentType="text/html" %>
<%@ page pageEncoding="UTF-8" %>

<%@page import="gov.bnl.gums.*"%>
<%@page import="gov.bnl.gums.util.StringUtil"%>
<%@page import="gov.bnl.gums.service.*"%>
<%@page import="gov.bnl.gums.configuration.*"%>
<%@page import="gov.bnl.gums.account.AccountMapper"%>
<%@page import="gov.bnl.gums.userGroup.UserGroup"%>
<%@page import="gov.bnl.gums.groupToAccount.GroupToAccountMapping"%>
<%@page import="gov.bnl.gums.hostToGroup.HostToGroupMapping"%>
<%@page import="java.net.URL"%>
<%@page import="java.io.File"%>
<%@page import="java.lang.StringBuffer"%>
<%@page import="java.util.*"%>

<jsp:useBean id="gums" scope="application" class="gov.bnl.gums.admin.GUMSAPIImpl" />

<%  String h2gMappingName = request.getParameter("h2gM"); if (h2gMappingName!=null) h2gMappingName=h2gMappingName.trim();%>
<%  String uris = request.getParameter("uris"); if (uris!=null) uris=uris.trim();%>
<%  String tempFile = request.getParameter("tf");%>
<%  boolean autoUpdate = (request.getParameter("aupdate") != null && request.getParameter("aupdate").equals("on"));%>

<%@include file="sideNav.jspf"%>

<jsp:include page="topNav.jsp" >
	<jsp:param name="version" value="<%=gums.getVersion()%>" />
	<jsp:param name="pageTitle" value="Merge Configuration" />
	<jsp:param name="pageDescription" value="Merge configuration into current configuration, replacing user groups, account mappers, and group to account mappings with the same name and source as well as insert group to account mappings into chosen host to group mapping" />
</jsp:include>

<%
Configuration configuration = null;
try {
	configuration = gums.getConfiguration();
}catch(Exception e){
	out.write("<p><div class=\"failure\">" + e.getMessage() + "</div></p>");
	return;
}
if (configuration!=null) {
	String message = null;
	if ( "merge".equals(request.getParameter("command")) ) {
		Configuration clonedConfiguration = (Configuration)configuration.clone();
		try{
			File f = new File(tempFile);
			if (!f.exists())
				throw new Exception("Temp file does not exist");
			
			Configuration newConfig = null;
			if (autoUpdate)
				newConfig = ConfigurationToolkit.parseConfigurationTemplates(uris, null);
			else
				newConfig = ConfigurationToolkit.parseConfigurationTemplates("file://"+tempFile, null);
			f.delete();
			
			// remove unchecked elements
			if (!autoUpdate)
				newConfig = ConfigurationWebToolkit.removeUncheckedG2AMappings(request, newConfig);
			
			// do merge
			clonedConfiguration.mergeConfigurationTemplate(newConfig, h2gMappingName, request.getParameter("rd") != null);
			
			// set auto-merging fields
			clonedConfiguration.setAutoMerge(autoUpdate);
			clonedConfiguration.setMergeHostToGroupMapping(h2gMappingName);
			clonedConfiguration.setMergeURIs(uris);
			
			// set configuration as current
			gums.setConfiguration(clonedConfiguration);
	
			message = "<div class=\"success\">Configuration has been merged.</div>";
		}catch(Exception e){
			message = "<div class=\"failure\">Error merging configuration: " + e.getMessage() + "</div>";
		}
	
		if(message!=null)
			out.write( "<tr><td colspan=\"2\">" + message + "</td></tr>" );		
			
		out.write(
			"</table></form>");
	}
	else if ( "choose".equals(request.getParameter("command")) || "choose-refresh".equals(request.getParameter("command")) ) {
		try{
			if (tempFile == null)
				throw new Exception("Missing tf URL parameter");
	
			Configuration newConfig = ConfigurationToolkit.parseConfigurationTemplates(uris, tempFile);
			boolean isRefresh = "choose-refresh".equals(request.getParameter("command"));
			boolean disabledWarning = false;
	
			// Create string for showing depricated group to account mappings
			StringBuffer sb = new StringBuffer("<tr><td colspan=10><input TYPE=CHECKBOX name=\"rd\"> Check to remove depricated group to account mapping(s): ");
			boolean depricatedG2AMappingsFound = false;
			HostToGroupMapping curH2gMapping = configuration.getHostToGroupMapping(h2gMappingName);
			Iterator it = configuration.getGroupToAccountMappings().values().iterator();
			while (it.hasNext()) {
				GroupToAccountMapping g2am = (GroupToAccountMapping)it.next();
				String g2amName = g2am.getName();
				if (g2am.getSource().equals(newConfig.getSource()) && newConfig.getGroupToAccountMapping(g2amName)==null) {
					if (depricatedG2AMappingsFound)
						sb.append(", ");
					sb.append(g2am.getName());
					depricatedG2AMappingsFound = true;
				}
			}
			sb.append("</td></tr>");
			
			%>
			<form action="mergeConfiguration.jsp" method="get">
			<input type="hidden" name="command" value="choose-refresh">
			<input type="hidden" name="h2gM" value="<%=h2gMappingName%>">
			<input type="hidden" name="uris" value="<%=uris%>">
			<input type="hidden" name="tf" value="<%=tempFile%>">
			<table id="form" cellpadding="2" cellspacing="2">
	
			<tr><td><h3>Select group to account mappings and associated elements from '<%=newConfig.getSource()%>' to import:</h3></td></tr>
			<%
			if (depricatedG2AMappingsFound)
				out.write(sb.toString());
			%>		
			<tr>
				<td>
					<table class="configElement" id="form" border="0" cellpadding="2" cellspacing="2" align="left">
						<tr>
			<%
			
			// Show group to account mappers from new config
			disabledWarning = false;
			int i = 0;
			HostToGroupMapping newH2gMapping = (HostToGroupMapping)newConfig.getHostToGroupMappings().get(0);
			it = StringUtil.toList(newH2gMapping.getGroupToAccountMappings()).iterator();
			while (it.hasNext()) {
				String g2amName = (String)it.next();
				GroupToAccountMapping newG2am = newConfig.getGroupToAccountMapping(g2amName);
				GroupToAccountMapping curG2am = null;
				if (curH2gMapping.getGroupToAccountMappings().contains(g2amName))
					curG2am = configuration.getGroupToAccountMapping(g2amName);
				%>
							<td nowrap>
								<input TYPE=CHECKBOX name="g<%=i%>"
				<%
				boolean sourceMatches = (curG2am!=null && curG2am.getSource().equals(newConfig.getSource()));
				if (request.getParameter("gsa")!=null)
					out.write("checked");
				else if (request.getParameter("gda")==null) {
					if (isRefresh) {
						if ("on".equals(request.getParameter("g"+i)))
							out.write("checked");
					}
					else if (curG2am!=null && sourceMatches)
						out.write("checked");
				}
				%>
								>
				<%=newG2am.getName()%>&nbsp;&nbsp;&nbsp;
							</td>
				<%
				if ((i+1)%4 == 0) {
					%>	
						</tr>
						<tr>
					<%
				}					
				i++;
			}
			%>
						</tr>
					</table>
			<%
				if (disabledWarning)
					out.write("<tr><td>WARNING: Cannot replace one or more group to account mappings (uncheckable) because their source is not set to '" + newConfig.getSource() +  "'</td></tr>");
			%>
				</td>
			</tr>		
	
			<tr>
		        <td>
		        	<div style="text-align: center;">
						<input type="submit" name="gsa" value="select all">
						<input type="submit" name="gda" value="deselect all">
		        	</div>
		        </td>
			</tr>
	
			<tr>
		        <td>
		        	<div style="text-align: center;">
		        		<button type="submit" onclick="document.forms[0].elements['command'].value='merge'; return true;">merge</button>
		        	</div>
		        </td>
			</tr>
	        
		</table>
	</form>
	<%
		}catch(Exception e){
			out.write( "<tr><td colspan=\"2\"><div class=\"failure\">Error during first stage of merge: " + e.getMessage() + "</div></td></tr>" );		
		}
	}
	else {
	%>
	<form action="mergeConfiguration.jsp" method="get">
		<input type="hidden" name="command" value="">
		<input type="hidden" name="tf" value="<%
			File temp = File.createTempFile("config",".fromuri");
			out.write(temp.getAbsolutePath());
			%>">
		<table id="form" border="0" cellpadding="2" cellspacing="2" align="center">
			<tr>
	            <td nowrap style="text-align: right;">
					Host to Group Mapping:
	            </td>
	            <td>
	                <%=ConfigurationWebToolkit.createSelectBox("h2gM",
	                    configuration.getHostToGroupMappings(),
	                    configuration.getMergeHostToGroupMapping(),
	                    null,
	                    false)%> (for inserting group to account mappings)
				</td>
	        </tr>
	        
	        <tr>
	            <td nowrap style="text-align: right;">
					Configuration URI(s):
	            </td>
	            <td>
					<input maxlength="256" size="64" name="uris" value="<%=ConfigurationWebToolkit.blankNull(configuration.getMergeURIs())%>"/>
	            </td>
	        </tr>
	        <tr>
	            <td nowrap style="text-align: right;">
	                i.e.
	            </td>
	            <td nowrap>
	                http://software.grid.iu.edu/pacman/tarballs/vo-version/gums.template
	            </td>
	        </tr>
	
	      <tr>
	        <td style="text-align: right;">Auto-merge:</td>
	        <td><input TYPE=CHECKBOX name="aupdate" id="aupdate" <%=configuration.isAutoMerge() ? "checked" : ""%>> (Merge all elements automatically on a regular basis)</td>
	      </tr>
	      
			<tr>
		        <td colspan=2>
		        	<div style="text-align: center;">
		        		<button type="submit" onclick="if (document.getElementById('aupdate').checked) document.forms[0].elements['command'].value='merge'; else document.forms[0].elements['command'].value='choose'; return true;">submit</button>
		        	</div>
		        </td>
			</tr>
	        
		</table>
	</form>
	<%
	}
}%>
<jsp:include page="bottomNav.jsp" >
	<jsp:param name="userDn" value="<%=gums.getCurrentDn()%>" />
</jsp:include>
