<%@ page contentType="text/html" %>
<%@ page pageEncoding="UTF-8" %>

<%@ page import="java.util.*" %>
<%@ page import="gov.bnl.gums.hostToGroup.*" %>
<%@ page import="gov.bnl.gums.groupToAccount.*" %>
<%@ page import="gov.bnl.gums.account.*" %>
<%@ page import="gov.bnl.gums.userGroup.*" %>
<%@ page import="gov.bnl.gums.configuration.*" %>
<%@ page import="gov.bnl.gums.util.StringUtil" %>
<%@ page import="gov.bnl.gums.service.ConfigurationWebToolkit" %>

<jsp:useBean id="gums" scope="application" class="gov.bnl.gums.admin.GUMSAPIImpl" />

<%@include file="sideNav.jspf"%>

<jsp:include page="topNav.jsp" >
	<jsp:param name="version" value="<%=gums.getVersion()%>" />
	<jsp:param name="pageTitle" value="Configuration Summary" />
	<jsp:param name="pageDescription" value="View configuration logic in a concise presentation" />
</jsp:include>

<%
String bgColor = "#FFEE77";
Configuration configuration = null;
try {
	configuration = gums.getConfiguration();
}catch(Exception e){
	out.write("<p><div class=\"failure\">" + e.getMessage() + "</div></p>");
}
if (configuration!=null) {
%>

<table id="form" cellpadding="2" cellspacing="2" border="1" width="95%">
<thead>
	<tr><th>Host To Group Mapping</th><th colspan="3">Group To Account Mapping</th><th colspan="6">User Group</th><th colspan="3">Account Mapper</th></tr>
	<tr><th>Name</th><th>Name</th><th>Acc. VO Subgroup</th><th>Accounting VO</th><th>Name</th><th>Type</th><th>Match FQAN</th><th>Accept Grid-Proxies</th><th>VO/Group</th><th>Role</th><th>Name</th><th>Type</th><th>Account</th></tr>
<thead>
<tbody>

<%
	Collection h2GMappings = configuration.getHostToGroupMappings();
	Iterator h2GMappingsIt = h2GMappings.iterator();
	while (h2GMappingsIt.hasNext()) {
		HostToGroupMapping h2GMapping = (HostToGroupMapping)h2GMappingsIt.next();
		if ("/DC=com/DC=example/OU=Services/CN=example.site.com".equals(h2GMapping.getName()))
			continue;
		if (!(h2GMapping instanceof CertificateHostToGroupMapping)) {
			out.write("<tr><td colspan=\"2\">Unknown host to group mapping type</td></tr>");
			continue;
		}
		CertificateHostToGroupMapping cH2GMapping = (CertificateHostToGroupMapping)h2GMapping;
		Collection groupToAccountMappings = StringUtil.toList(cH2GMapping.getGroupToAccountMappings());
		Iterator g2AMappingsIt = groupToAccountMappings.iterator();
		String lastH2GMapping = null;
		String lastG2AMapping = null;
		String lastUserGroup = null;
		while (g2AMappingsIt.hasNext()) {
			GroupToAccountMapping g2AMapping = (GroupToAccountMapping)configuration.getGroupToAccountMapping( (String)g2AMappingsIt.next() );
			Collection userGroups = StringUtil.toList(g2AMapping.getUserGroups());
			Iterator userGroupsIt = userGroups.iterator();
			while (userGroupsIt.hasNext()) {
				UserGroup userGroup = (UserGroup)configuration.getUserGroup( (String)userGroupsIt.next() );
				Collection accountMappers = StringUtil.toList(g2AMapping.getAccountMappers());
				Iterator accountMappersIt = accountMappers.iterator();
				while (accountMappersIt.hasNext()) {
					AccountMapper accountMapper = (AccountMapper)configuration.getAccountMapper( (String)accountMappersIt.next() );
	%>
	
		<tr>
			<%= (!cH2GMapping.getName().equals(lastH2GMapping) ? "<td bgcolor=\"#FFEE77\"><a href=\"hostToGroupMappings.jsp?command=edit&name="+cH2GMapping.getName()+"\">"+cH2GMapping.getName().replaceAll(",","<br>")+"</a></td>" : "<td></td>") %>
			<%= (!g2AMapping.getName().equals(lastG2AMapping) ? "<td bgcolor=\""+bgColor+"\"><a href=\"groupToAccountMappings.jsp?command=edit&name=" + 
					g2AMapping.getName() + "\">" + g2AMapping.getName() + "</a></td><td bgcolor=\""+bgColor+"\">" + 
					g2AMapping.getAccountingVoSubgroup() + "&nbsp;</td><td bgcolor=\""+bgColor+"\">" + 
					g2AMapping.getAccountingVo() + "&nbsp;</td>" : "<td></td><td></td><td></td>") %>
			<%= (!userGroup.getName().equals(lastUserGroup) ? "<td bgcolor=\""+bgColor+"\"><a href=\"userGroups.jsp?command=edit&name=" + 
					userGroup.getName() + "\">" + userGroup.getName() + "</a></td><td bgcolor=\""+bgColor+"\">" + 
					userGroup.getClass().getName().replaceAll(".*\\.","") + "</td><td bgcolor=\""+bgColor+"\">" + 
					(userGroup instanceof VOMSUserGroup ? ((VOMSUserGroup)userGroup).getMatchFQAN() : "") + "</td><td bgcolor=\""+bgColor+"\">" + 
					(userGroup instanceof VOMSUserGroup ? ((VOMSUserGroup)userGroup).isAcceptProxyWithoutFQAN() : "") + "</td><td bgcolor=\""+bgColor+"\">" + 
					(userGroup instanceof VOMSUserGroup ? ((VOMSUserGroup)userGroup).getVoGroup() : "") + "&nbsp;</td><td bgcolor=\""+bgColor+"\">" + 
					(userGroup instanceof VOMSUserGroup ? ((VOMSUserGroup)userGroup).getRole() : "") + "&nbsp;</td>" : "<td></td><td></td><td></td><td></td><td></td><td></td>") %>
			<%= "<td bgcolor=\""+bgColor+"\"><a href=\"accountMappers.jsp?command=edit&name=" + 
					accountMapper.getName() + "\">" + 
					accountMapper.getName().replaceAll(".*\\.","") + "</a></td><td bgcolor=\""+bgColor+"\">" + 
					accountMapper.getClass().getName() + "</td><td bgcolor=\""+bgColor+"\">" + 
					(accountMapper instanceof AccountPoolMapper ? ((AccountPoolMapper)accountMapper).getAssignments() : (accountMapper instanceof GroupAccountMapper ? ((GroupAccountMapper)accountMapper).getAccountName() : "")) 
					+ "</td>" %>
		</tr>
		
	<%
					lastH2GMapping = cH2GMapping.getName();
					lastG2AMapping = g2AMapping.getName();
					lastUserGroup = userGroup.getName();
				}
			}
		}
	}
%>

</tbody>
</table>

<%}%>
<jsp:include page="bottomNav.jsp" >
	<jsp:param name="userDn" value="<%=gums.getCurrentDn()%>" />
</jsp:include>
